from math import log
from matplotlib import pyplot

"""
Define distributions and plot, then compare using cross-entropy
"""
events = ['red', 'green', 'blue']
p = [0.10, 0.40, 0.50]
q = [0.80, 0.15, 0.05]
print('P=%.3f Q=%.3f' % (sum(p), sum(q)))

# plot first distribution
pyplot.subplot(2,1,1)
pyplot.bar(events, p)

# plot second distribution
pyplot.subplot(2,1,2)
pyplot.bar(events, q)

# show the plot
pyplot.show()

# Define entropy, cross-entropy and KL-divergence functions
def cross_entropy(p, q):
    return -sum([p[i]*log(q[i]) for i in range(len(p))])

def kl_div(p,q):
	return sum(p[i] * log(p[i]/q[i]) for i in range(len(p)))
 
def entropy(p):
	return -sum([p[i] * log(p[i]) for i in range(len(p))])

# Use cross_entropy() to compare P and Q 
ce_pq = cross_entropy(p,q)
ce_qp = cross_entropy(q,p)
print('H(P,Q): %.3f' % ce_pq)
print('H(Q,P): %.3f' % ce_qp)

# Use kl_div() to compare P and Q 
kl_pq = kl_div(p,q)
kl_qp = kl_div(q,p)
print('H(P,Q): %.3f' % kl_pq)
print('H(Q,P): %.3f' % kl_qp)

# use cross_entropy() to compute entropy of P and Q 
ce_pp = cross_entropy(p,p)
ce_qq = cross_entropy(q,q)
print('H(P,P): %.3f' % ce_pp)
print('H(Q,Q): %.3f' % ce_qq)

# use entropy() to compute entropy of P and Q 
ent_p = entropy(p)
ent_q = entropy(q)
print('H(P): %.3f' % ent_p)
print('H(Q): %.3f' % ent_q)

input()
print('Compare CE, KL_div and entropy of P -> Q')
print('H(P): %.3f' % ent_p)
print('H(P,Q): %.3f' % kl_pq)
print('H(P,Q): %.3f' % ce_pq)
