# Calculate cross entropy loss for a classification problem
from math import log
from numpy import mean

# Define cross-entropy
def cross_entropy(p, q):
	return -sum([p[i]*log(q[i]) for i in range(len(p))])

"""
Nb: here we assume that we already have a classifier, and
it has returned the following class probabilities yhat:  
"""
y = [1, 1, 1, 1, 1, 0, 0, 0, 0, 0]
yhat = [0.8, 0.9, 0.9, 0.6, 0.8, 0.1, 0.4, 0.2, 0.1, 0.3]

# calculate cross entropy for each data object
results = list()
for i in range(len(y)):
	# create the distribution for each event {0, 1}
	expected = [1.0 - y[i], y[i]]
	predicted = [1.0 - yhat[i], yhat[i]]
	# calculate cross entropy for the two events
	ce = cross_entropy(expected, predicted)
	print('>[y=%.1f, yhat=%.1f] ce: %.3f' % (y[i], yhat[i], ce))
	results.append(ce)

# calculate the average cross entropy
mean_ce = mean(results)
print('Average Cross Entropy: %.3f' % mean_ce)

"""
The ML task is to adjust the mapping from input data (not included here) to class probabilities, to minimise the average cross entropy loss.
"""

