import numpy as np 
import pandas as pd

# load the "clean" data
clean_data = pd.read_csv("./data/voltage_ESS1518.csv",
                         header=None)   

# Generate exponentially-correlated standard Gaussian noise
mu, sigma, tau = 0.0, 1.0, 2.0
f = np.exp(-1.0/tau)
noise = np.random.normal(mu, sigma, clean_data.shape) 
for i in range(clean_data.shape[0]):
    for j in range(1,clean_data.shape[1]):
        noise[i,j] = f*noise[i,j-1] + np.sqrt(1-f**2)*noise[i,j]
        
# Add noise to the clean data
scale = 5.0 # variance of voltage measurement
noisy_data = clean_data + scale * noise

# Save noisy data
noisy_data.to_csv("./data/corr_noisy_data.csv", index=False)