import numpy as np 
import pandas as pd

# load the "clean" data
clean_data = pd.read_csv("./data/voltage_ESS1518.csv",
                         header=None)

# Generate iid standard Gaussian noise
mu, sigma = 0.0, 0.1
noise = np.random.normal(mu, sigma, clean_data.shape)  

# Add noise to the clean data
scale = 5.0 # variance of voltage measurement    
noisy_data = clean_data + scale * noise

# Save noisy data
noisy_data.to_csv("./data/noisy_data.csv", index=False)