import pandas as pd
import numpy as np
from sklearn.linear_model import LogisticRegression

# Load Dataset
# num_features is 366*24 = 8784 hours in a leap year
# num_classes = 3 i.e. 3 phases

features_ar = np.array(pd.read_csv('./data/noisy_data.csv',
                                   header=None))
labels_ar = np.array(pd.read_csv('./data/phase_ID.csv',
                                 header=None))
                     
X = features_ar.transpose()
y = labels_ar.squeeze()

training_size = 30 # max 44
clf = LogisticRegression(multi_class='multinomial',
                         solver='lbfgs',
                         random_state=0,
                         max_iter=1000
                         ).fit(X[:training_size,:], y[:training_size])

print(clf.predict(X[training_size:, :]))
print(y[training_size:])

print(clf.predict_proba(X[training_size:, :]))

print(clf.score(X, y))
